const path = require('path')

const publicPath = '/wj-developer'
const port = 9400
const CompressionWebpackPlugin = require('compression-webpack-plugin')
const productionGzipExtensions = ['js', 'css']
const proxy = {
//   '/sso': {
//     target: 'http://10.102.1.182:9000',
//   },
//   '/design': {
//     target: 'http://10.102.1.182:9000',
//   },

  '/sso': {
    target: 'http://10.102.1.182:9000',
  },
  '/design': {
    target: 'http://127.0.0.1:17010',
  },
  '/cdn': {
    target: 'http://127.0.0.1:3000',
  },

}

module.exports = {
  publicPath,
  outputDir: 'dist',
  assetsDir: 'static',
  productionSourceMap: false,
  devServer: {
    port,
    overlay: {
      warnings: false,
      errors: true,
    },
    proxy,
  },
  configureWebpack: {
    resolve: {
      alias: {
        vue$: 'vue/dist/vue.esm.js',
        '@': path.join(__dirname, 'src'),
      },
    },
    plugins: [
      new CompressionWebpackPlugin({
        algorithm: 'gzip',
        test: new RegExp('\\.(' + productionGzipExtensions.join('|') + ')$'),
        threshold: 10240,
        minRatio: 0.8,
      }),
    ],
  },
}
